package com.huimv.guowei.admin.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.entity.DuckEggTextureInfo;
import com.huimv.guowei.admin.entity.DuckIncubateInfo;
import com.huimv.guowei.admin.service.IBaseDuckInfoService;
import com.huimv.guowei.admin.service.IDuckIncubateInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Date;
import java.util.Map;

/**
 * <p>
 * 孵化登记 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@RestController
@RequestMapping("/duck-incubate-info")
@CrossOrigin
public class DuckIncubateInfoController {
    @Autowired
    private IDuckIncubateInfoService duckIncubateInfoService;
    @Resource
    private IBaseDuckInfoService baseDuckInfoService;

    @PostMapping("/addInfo")
    public Result addInfo(@RequestBody DuckIncubateInfo duckIncubateInfo){
        BaseDuckInfo baseDuckInfo = baseDuckInfoService.getOne(new QueryWrapper<BaseDuckInfo>().eq("duck_num", duckIncubateInfo.getDuckNum()));
        if (baseDuckInfo.getDuckSex() == 0){
            return new Result(10001,"雄鸭无法新增孵化信息!",false);
        }
        if (baseDuckInfo.getIsCage() == 1){
            return new Result(10001,"鸭只已离场!",false);
        }
        Date incubateTime = duckIncubateInfo.getIncubateTime();
        Date layEggsTime = duckIncubateInfo.getLayEggsTime();
        if (layEggsTime.compareTo(incubateTime) > 0){
            return new Result(10001,"孵化日期不能早于产蛋日期!",false);
        }
        duckIncubateInfoService.save(duckIncubateInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/deleteInfo")
    public Result deleteInfo(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        duckIncubateInfoService.removeById(id);
        return Result.SUCCESS();
    }

    @PostMapping("/updateInfo")
    public Result updateInfo(@RequestBody DuckIncubateInfo duckIncubateInfo){
        duckIncubateInfoService.updateById(duckIncubateInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/getById")
    public Result getById(@RequestBody Map<String, String> paramsMap){
        return new Result(ResultCode.SUCCESS,duckIncubateInfoService.getById(paramsMap.get("id")));
    }

    @PostMapping("/listInfo")
    public Result listInfo(@RequestBody Map<String, String> paramsMap){
        return duckIncubateInfoService.listLimitInfo(paramsMap);
    }

    @PostMapping("/listPageInfo")
    public Result listPageInfo(@RequestBody Map<String, String> paramsMap){
        return duckIncubateInfoService.listPageInfo(paramsMap);
    }

    @PostMapping("/listWeekInfo")
    public Result listWeekInfo(@RequestBody Map<String, String> paramsMap){
        return duckIncubateInfoService.listWeekInfo(paramsMap);
    }

}
